"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformToImmediatelyInvokedFunctionExpression = void 0;
const utils_1 = require("../../utils");
const lua_ast_1 = require("./lua-ast");
const scope_1 = require("./scope");
function transformToImmediatelyInvokedFunctionExpression(context, transformFunction, tsOriginal) {
    scope_1.pushScope(context, scope_1.ScopeType.Function);
    const { statements, result } = transformFunction();
    scope_1.popScope(context);
    return lua_ast_1.createImmediatelyInvokedFunctionExpression(utils_1.castArray(statements), result, tsOriginal);
}
exports.transformToImmediatelyInvokedFunctionExpression = transformToImmediatelyInvokedFunctionExpression;
//# sourceMappingURL=transform.js.map